/* -*- c++ -*- */
/* 
 * Copyright 2019 Jay Arrowfield.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <gnuradio/io_signature.h>
#include "message_debug_impl.h"

namespace gr {
  namespace jay {

    message_debug::sptr
    message_debug::make()
    {
      return gnuradio::get_initial_sptr
        (new message_debug_impl());
    }

    /*
     * The private constructor
     */
    message_debug_impl::message_debug_impl()
      : gr::block("message_debug",
              gr::io_signature::make(0, 0, sizeof(int)),
              gr::io_signature::make(0, 0, sizeof(int)))
    {
		m_msg_port_in = pmt::mp("control");
		m_msg_port_out = pmt::mp("status");
		message_port_register_in(m_msg_port_in);
		message_port_register_out(m_msg_port_out);
		set_msg_handler(m_msg_port_in, boost::bind(&message_debug_impl::set_msg, this, _1));		
	}

    /*
     * Our virtual destructor.
     */
    message_debug_impl::~message_debug_impl()
    {
	}

	void message_debug_impl::print_pair(pmt::pmt_t pair)
	{
		pmt::pmt_t key = pmt::car(pair);
		pmt::pmt_t val = pmt::cdr(pair);
		if (pmt::is_integer(val)) 
		{
			fprintf(stderr, "[%s=%d]", pmt::symbol_to_string(key).c_str(), (int) pmt::to_long(val));
		} 
		else if (pmt::is_real(val)) 
		{
			fprintf(stderr, "[%s=%f]", pmt::symbol_to_string(key).c_str(), pmt::to_float(val));
		} 
		else if (pmt::is_bool(val)) 
		{
			fprintf(stderr, "[%s=%d]", pmt::symbol_to_string(key).c_str(), pmt::to_bool(val));
		}
		fprintf(stderr, "\n");
	}

	void message_debug_impl::set_msg(pmt::pmt_t msg)
	{
		if (pmt::is_dict(msg))
		{
			pmt::pmt_t items = pmt::dict_items(msg);
			try
			{
				size_t len_items = pmt::length(items);
				for (int i=0; i < len_items; i++)
				{	
					pmt::pmt_t pair = pmt::nth(i, items);
					print_pair(pair);
				}
			}
			catch (const std::exception& e)
			{
				print_pair(msg);
			}
		}
		else
		{
			fprintf(stderr, "%s\n", pmt::symbol_to_string(msg).c_str());
		}
	}

    void
    message_debug_impl::forecast (int noutput_items, gr_vector_int &ninput_items_required)
    {
		ninput_items_required[0] = noutput_items;
    }

    int
    message_debug_impl::general_work (int noutput_items,
                       gr_vector_int &ninput_items,
                       gr_vector_const_void_star &input_items,
                       gr_vector_void_star &output_items)
    {
      const int *in = (const int *) input_items[0];
      int *out = (int *) output_items[0];

      // Do <+signal processing+>
      // Tell runtime system how many input items we consumed on
      // each input stream.
      consume_each (noutput_items);

      // Tell runtime system how many output items we produced.
      return noutput_items;
    }

  } /* namespace jay */
} /* namespace gr */

